<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.3 of December 3, 2004 on January 29, 2008 at 2:26:57 pm</time-stamp>


<methods>
<class-id>CraftedSmalltalk.CodeProbe class</class-id> <category>utilities</category>

<body package="Utils" selector="insertProbeIntoClass:selector:sourceString:offset:">insertProbeIntoClass: aClass selector: aSymbol sourceString: aString offset: aNumber 
	| method probedMethod probe interval methodString |
	method := aClass compiledMethodAt: aSymbol.
	methodString := method nameString.
	method isProbed 
		ifTrue: 
			[^Transcript
				show: 'NOTE: Method ' , methodString , ' already probed, skipping';
				cr].
	probedMethod := method newFullProbedMethod.
	probe := self new.
	interval := method getSource 
				findString: aString
				startingAt: 1
				ifAbsent: 1.
	interval := interval + aNumber.
	probe record: (probedMethod probeRecordFor: (interval to: interval)).
	probedMethod addProbe: probe.
	probe unconditionallyInsertInto: probedMethod replacing: method.
	Transcript
		show: methodString , ' added probe at ''' , aString , '''';
		cr</body>
</methods>

</st-source>
